VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "kWTHBlockElement"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Public Enum kwth_block_element_type
    betBODY
    betH1
    betH2
    betH3
    betH4
    betH5
    betH6
    betP
    betBLOCKQUOTE
    betUL
    betLI
    betADDRESS
    betPRE
End Enum

Private m_type As kwth_inline_element_type
Private m_elements() As kWTHBlockElement
Private m_elements_count As Integer
Private m_content As kWTHInlineElement

Private Sub Class_Initialize()
    m_elements_count = -1
End Sub
Public Sub SetElementType(ByVal etype As kwth_inline_element_type)
    m_type = etype
End Sub

Private Sub Class_Terminate()
    Set m_content = Nothing
    Dim i As Integer
    For i = 0 To m_elements_count
        Set m_elements(i) = Nothing
    Next i
End Sub

Public Sub AddElement(ByVal content As kWTHBlockElement)
    m_elements_count = m_elements_count + 1
    ReDim Preserve m_elements(m_elements_count) As kWTHBlockElement
    Set m_elements(m_elements_count) = content
End Sub

Public Sub SetContent(ByVal content As kWTHInlineElement)
    Set m_content = content
End Sub

Public Function CreateTag() As String
    Dim tmpstr As String
    
    tmpstr = "<" & Me.GetElementName & ">"
    
    If Not (m_content Is Nothing) Then
        tmpstr = tmpstr & m_content.CreateTag
    Else
        tmpstr = tmpstr & vbCrLf
    End If
    
    Dim i As Integer
    For i = 0 To m_elements_count
        tmpstr = tmpstr & m_elements(i).CreateTag
    Next i
    
    tmpstr = tmpstr & "</" & Me.GetElementName & ">" & vbCrLf
    
    CreateTag = tmpstr
End Function

Public Function GetElementName() As String
    Dim tmpstr As String
    Select Case m_type
        Case kwth_block_element_type.betBODY:         tmpstr = "body"
        Case kwth_block_element_type.betH1:           tmpstr = "h1"
        Case kwth_block_element_type.betH2:           tmpstr = "h2"
        Case kwth_block_element_type.betH3:           tmpstr = "h3"
        Case kwth_block_element_type.betH4:           tmpstr = "h4"
        Case kwth_block_element_type.betH5:           tmpstr = "h5"
        Case kwth_block_element_type.betH6:           tmpstr = "h6"
        Case kwth_block_element_type.betP:            tmpstr = "p"
        Case kwth_block_element_type.betUL:           tmpstr = "ul"
        Case kwth_block_element_type.betLI:           tmpstr = "li"
        Case kwth_block_element_type.betBLOCKQUOTE:   tmpstr = "blockquote"
        Case kwth_block_element_type.betADDRESS:      tmpstr = "address"
        Case kwth_block_element_type.betPRE:          tmpstr = "pre"
    End Select
    GetElementName = tmpstr
End Function

