VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "kWTHInlineElement"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Public Enum kwth_inline_element_type
    ietNORMALTEXT
    ietEM
    ietSTRONG
    ietABBR
    ietCITE
    ietCODE
    ietDFN
    ietKBD
    ietSAMP
    ietVAR
    ietA
End Enum

Private m_type As kwth_inline_element_type
Private m_elements() As kWTHInlineElement
Private m_elements_count As Integer
Private m_content As String

Private Sub Class_Initialize()
    m_elements_count = -1
End Sub
Public Sub SetElementType(ByVal etype As kwth_inline_element_type)
    m_type = etype
End Sub

Private Sub Class_Terminate()
    Dim i As Integer
    For i = 0 To m_elements_count
        Set m_elements(i) = Nothing
    Next i
End Sub

Public Sub AddElement(ByVal content As kWTHInlineElement)
    m_elements_count = m_elements_count + 1
    ReDim Preserve m_elements(m_elements_count) As kWTHInlineElement
    Set m_elements(m_elements_count) = content
End Sub

Public Sub SetContent(ByVal content As String)
    m_content = content
End Sub

Public Function CreateTag() As String
    Dim tmpstr As String
    
    If Me.GetElementName <> "" Then
        tmpstr = "<" & Me.GetElementName & ">"
    End If
    
    tmpstr = tmpstr & HTMLSpacialChars(m_content)
    
    Dim i As Integer
    For i = 0 To m_elements_count
        tmpstr = tmpstr & m_elements(i).CreateTag
    Next i
    
    If Me.GetElementName <> "" Then
        tmpstr = tmpstr & "</" & Me.GetElementName & ">"
    End If
    
    CreateTag = tmpstr
End Function

Public Function GetElementName() As String
    Dim tmpstr As String
    Select Case m_type
        Case kwth_inline_element_type.ietNORMALTEXT: tmpstr = ""
        Case kwth_inline_element_type.ietEM:         tmpstr = "em"
        Case kwth_inline_element_type.ietSTRONG:     tmpstr = "strong"
        Case kwth_inline_element_type.ietABBR:       tmpstr = "abbr"
        Case kwth_inline_element_type.ietCITE:       tmpstr = "cite"
        Case kwth_inline_element_type.ietCODE:       tmpstr = "code"
        Case kwth_inline_element_type.ietDFN:        tmpstr = "dfn"
        Case kwth_inline_element_type.ietKBD:        tmpstr = "kbd"
        Case kwth_inline_element_type.ietSAMP:       tmpstr = "samp"
        Case kwth_inline_element_type.ietVAR:        tmpstr = "var"
        Case kwth_inline_element_type.ietA:          tmpstr = "a"
    End Select
    GetElementName = tmpstr
End Function

Private Function HTMLSpacialChars(ByVal str As String) As String
    Dim tmpstr As String
    tmpstr = str
    
    tmpstr = Replace(tmpstr, "&", "&amp;")
    tmpstr = Replace(tmpstr, "<", "&lt;")
    tmpstr = Replace(tmpstr, ">", "&gt;")
    
    HTMLSpacialChars = tmpstr
End Function
