VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "kWTHSaveFileDialog"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
Private Declare Function GetSaveFileName Lib "comdlg32.dll" Alias "GetSaveFileNameA" (pOpenfilename As OPENFILENAME) As Long

Private Type OPENFILENAME
    lStructSize       As Long
    hwndOwner         As Long
    hInstance         As Long
    lpstrFilter       As String
    lpstrCustomFilter As String
    nMaxCustFilter    As Long
    nFilterIndex      As Long
    lpstrFile         As String
    nMaxFile          As Long
    lpstrFileTitle    As String
    nMaxFileTitle     As Long
    lpstrInitialDir   As String
    lpstrTitle        As String
    flags             As Long
    nFileOffset       As Integer
    nFileExtension    As Integer
    lpstrDefExt       As String
    lCustData         As Long
    lpfnHook          As Long
    lpTemplateName    As String
End Type
Private Const OFN_HIDEREADONLY = &H4
Private Const OFN_OVERWRITEPROMPT = &H2
Private Const OFN_FILEMUSTEXIST = &H1000
Private Const OFN_PATHMUSTEXIST = &H800
Private Const OFN_EXPLORER = &H80000

Private m_iscancel As Boolean
Private m_filter As String
Private m_path As String
Private m_initialdir As String

Private Sub Class_Initialize()
    m_iscancel = False
End Sub

Public Property Get IsCancel() As Boolean
    IsCancel = m_iscancel
End Property

Public Property Let Filter(ByVal Filter As String)
    m_filter = Filter
End Property
Public Property Get Filter() As String
    Filter = m_filter
End Property

Public Property Let InitialDir(ByVal idir As String)
    m_initialdir = idir
End Property
Public Property Get InitialDir() As String
    InitialDir = m_initialdir
End Property

Public Property Get path() As String
    path = m_path
End Property

Public Sub ShowDialog()
    Dim o As OPENFILENAME
    Dim ret As Long
    Dim tmpstr As String
        
    With o
        .lStructSize = Len(o)
        .hwndOwner = 0&
        .hInstance = 0&
        .lpstrFilter = Me.Filter
        .nFilterIndex = 1
        .lpstrFile = String$(512, Chr$(0))
        .nMaxFile = 512
        .lpstrFileTitle = String$(512, Chr$(0))
        .nMaxFileTitle = 512
        .lpstrInitialDir = Me.InitialDir
        .lpstrTitle = "Otĕۑ"
        .flags = OFN_PATHMUSTEXIST Or OFN_FILEMUSTEXIST Or OFN_HIDEREADONLY Or OFN_OVERWRITEPROMPT
    End With
    
    ret = GetSaveFileName(o)
    If ret = 0 Then
        m_path = ""
        m_iscancel = True
    Else
        m_path = Left(o.lpstrFile, InStr(o.lpstrFile, vbNullChar) - 1)
        m_iscancel = False
    End If
End Sub

